/**********************************************************
TReaderE2  3.0 for E2 
Written  by Strelok Vlad Kolerts
19/01/2009
Email: admin@mobsk.org.ua
ICQ: 497123239

Thanks to Lasly and kidscracker
***********************************************************/
#ifndef _TEDITOR_H
#define	_TEDITOR_H

#define QT_NO_DRAGANDDROP
#define QT_NO_PROPERTIES

#include <ZKbMainWidget.h>
#include <ZAppInfoArea.h>
#include <ZScrollPanel.h>
#include <ZMultiLineEdit.h>
#include <ZSoftKey.h>
#include <stdio.h>
#include <stdlib.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qtextcodec.h>



class TEditor : public ZKbMainWidget
{
	public:
    TEditor();
    ~TEditor();
	
	ZScrollPanel*	panel;
	ZAppInfoArea*	EditInfo;
	ZMultiLineEdit*	memo;
	ZSoftKey* 		softKey;
	
	void addText(QString text);
	void SetText(QString text);
    void MarkBegin();
    void MarkEnd();
    void atBegin();
    void atEnd();
    void BlockCopy();
    void BlockCut();
    bool isMarked;
    
  private:
    int m_iMarkStartX;
    int m_iMarkStartY;
      
  protected:
    virtual void keyPressEvent(QKeyEvent* e);    
    
};
#endif	/* _TEDITOR_H */
