/**********************************************************
TReaderE2  3.0 for E2 
Written  by Strelok Vlad Kolerts
19/01/2009
Email: admin@mobsk.org.ua
ICQ: 497123239

Thanks to Lasly and kidscracker
***********************************************************/
#ifndef _TREADER_H
#define	_TREADER_H

#define QT_NO_DRAGANDDROP
#define QT_NO_PROPERTIES
#include <ZApplication.h>
#include <ZKbMainWidget.h>
#include <ZAppInfoArea.h>
#include <qfontmanager_qws.h>
#include <qfontdatabase.h>
#include <qtextstream.h>
#include <qtimer.h>
#include <stdio.h>
#include <stdlib.h>
#include <qfile.h>

#define  title "TReader 3.0.1"	
#define  text1 "Text reader for ROKR E2"	
#define  text2 "(c)Written by Strelok Vlad Kolerts"
#define  text3 "admin@mobsk.org.ua"	
#define  text4 "http://MotoFan.RU"

#define codec_num 2 // - 

#include "TEditor.h"

/////////////////////////////////////////////////////////////////////////////////////

class TReader : public ZKbMainWidget
{
	Q_OBJECT	
public:
	TReader();
	~TReader();
	
//begin---- , , 
	TEditor*	tEditor;
	ZAppInfoArea*	EditInfo;
	
	QString 	path;
	QPixmap*	p_field;	
	QPixmap		about_icon;
	QPainter	p;
	QWMatrix	matrix;
	
	QTimer*		timer;
	
	QString		FileName;
	//QStringList 	textUtf, textAnsi;
	QStringList 	text[codec_num];	// [inside][codec]
	QString			text_edit;
	
	int inside_type;
	
	bool open;
	bool finish_open;
	//bool editor_add;
	
	int y, x;
	int font_size, font_codec, font_bold;
	bool font_ital;
	
	int num_line[codec_num];
	int line_step, line_vis, line_vis_px;
	
	int scroll_pos, scroll_size;
	
	QColor bg_color, font_color;
	
	bool line_up, line_down, move_left, move_right;
	bool rotate_90;
	bool rotate_chk;
	
	int exit_count;
	bool edit, exit;

//end---- , , 

//   

	void openFile( QString tfile , int type);

	void TextBrowse();
	void paintAbout();
	
	void lineUp();
	void lineDown();
	void moveLeft();
	void moveRight();
	void pageUp();
	void pageDown();
	void fontPlus();;
	void fontMinus();
	void fontBold();
	void fontItalic();
	void fontCodec();
	void Rotate90();
	void Inside();
	void InsideRecount();
	//void editorAdd();

	void keyPressEvent(QKeyEvent* k);
	void keyReleaseEvent(QKeyEvent* k);

	void fontChange(int font_chng);
	QString getProgramDir ( const QString &AFileName );
	QString getFmDir();
	
public slots:
	void action();
};

#endif	/* _TREADER_H */
